<?php

use OSS\OssClient;

function handler($event, $context) {
    // 设置时区
    date_default_timezone_set('PRC');

    // 获取存储桶名称
    $bucket = 'hongfs-backup-mysql-r7b0pl3buuwrg9g3';
    // 获取存储桶地域
    $region = 'cn-shenzhen';

    // 主机
    $host = 'mysql.hongfs.cn';
    // 端口
    $port = '3306';
    // 用户名
    $user = 'hongfs';
    // 密码
    $password = 'FKDdjYVV813lfj3H';
    // 数据库名称
    $database = 'hongfs';

    // 备份文件名
    $filename = $database . '-' . date('YmdHis') . '.sql';
    // 临时存储路径
    $filepath = getenv('HOME') . '/' . $filename;

    // 执行备份
    // 57 指的是 mysql-5.7 版本。如果是 8.0 则需要换成 80
    exec(sprintf('%smysqldump-57 --host=%s --port=%s --user=%s --password=%s --compact %s > %s', getenv('FC_FUNC_CODE_PATH'), $host, $port, $user, $password, $database, $filepath));

    if(!is_file($filepath)) {
        return '失败';
    }

    // 实例化 OSS
    $oss = new OssClient(
        $context['credentials']['accessKeyId'],
        $context['credentials']['accessKeySecret'],
        'https://oss-' . $region . '-internal.aliyuncs.com',
        false,
        $context['credentials']['securityToken']
    );

    // 上传文件
    $oss->uploadFile($bucket, 'backup/' . $filename, $filepath);

    return '完成';
}
